# TO DO
#
# test of [ !!!!!!!!
#
# subsetting operation on arrayData is somehow required
# and already implemented BUT NOT TESTED AND think about
# a simultanous operation on both the epxrSetArray-Object
# and the arrayData-Object or even more on a combined
# class object to avoid inconsistencies

# /**
#
# \name{initClasses}
#
# \title{dummy to initialize classes, methods and generics}
#
# \alias{initClasses}
#
# \keyword{}
#
# \description{
#}
#
# \value{}
#
#
# \arguments{
#  \item{where}{where}
# }
# 
# \details{}
#
# \seealso{\code{}}
#
# \examples{
#      nR <- new("normaliseResult")
#      stopifnot( class(nR) == "normaliseResult" )
#      aD <- new("arrayData")
#      stopifnot( class(aD) == "arrayData" )
# }
#
# \author{Andreas Buness <a.buness@dkfz.de>}
# */

initClasses <- function(where){
           
  setClass(Class="arrayData", representation =
           representation(intensities="array", weights="ANY", spotattr="data.frame", hybattr="data.frame"),
           prototype = prototype(intensities=NULL, weights=NULL, spotattr=NULL, hybattr=NULL),
           where=where)

  setMethod("initialize", "arrayData", function(.Object, intensities=NULL, weights=NULL, spotattr=NULL, hybattr=NULL){

    if( ! is.null(intensities) ){
      .Object@intensities <- intensities
    }
    if( ! is.null(intensities) ){
      .Object@weights <- weights
    }
    if( ! is.null(spotattr) ){
      .Object@spotattr <- spotattr
    }
    if( ! is.null(hybattr) ){
      .Object@hybattr <- hybattr
    }
    if( ! is.null(.Object@intensities) ){
      # at least two channels
      stopifnot(dim(.Object@intensities)[2] >= 2)
      # specific channel names are required
      stopifnot( all(c("Cy3","Cy5") %in% dimnames(.Object@intensities)[[2]]) ) 
    }
    if( ! is.null(.Object@intensities) & ! is.null(.Object@weights) ){
      stopifnot( length(dim(.Object@intensities)) == 3 )
      stopifnot( length(dim(.Object@weights)) == 2 )
      stopifnot( dim(.Object@intensities)[1] == dim(.Object@weights)[1] )
      stopifnot( dim(.Object@intensities)[3] == dim(.Object@weights)[2] )
    }
    if( ! is.null(.Object@intensities) & ! is.null(.Object@spotattr) ){
      stopifnot( length(dim(.Object@intensities)) == 3 )
      stopifnot( length(dim(.Object@spotattr)) == 2 |
                 length(dim(.Object@spotattr)) == 1 )
      stopifnot( dim(.Object@intensities)[1] == dim(.Object@spotattr)[1] )
    }
    if( ! is.null(.Object@intensities) & ! is.null(.Object@hybattr) ){
      stopifnot( length(dim(.Object@intensities)) == 3 )
      stopifnot( length(dim(.Object@hybattr)) == 2 )
      stopifnot( dim(.Object@intensities)[3] == dim(.Object@hybattr)[1] )
    }

    if( ! is.null(.Object@weights) ){
      stopifnot( max(.Object@weights) <= 1 )
      stopifnot( min(.Object@weights) >= 0 )
    }
    
    return(.Object)
  }, where=where)
  
  setGeneric("getIntensities", function(object) standardGeneric("getIntensities"), where=where)
  setMethod("getIntensities", "arrayData", function(object){return(object@intensities)}, where=where)
  
  setGeneric("getWeights", function(object) standardGeneric("getWeights"), where=where)
  setMethod("getWeights", "arrayData", function(object){return(object@weights)}, where=where)
  
  setGeneric("getSpotAttr", function(object) standardGeneric("getSpotAttr"), where=where)
  setMethod("getSpotAttr", "arrayData", function(object){return(object@spotattr)}, where=where)

   
  setGeneric("getHybAttr", function(object) standardGeneric("getHybAttr"), where=where)
  setMethod("getHybAttr", "arrayData", function(object) object@hybattr, where=where)

  # [ taken from exprSetArray-class
  setMethod("[", "arrayData", function(x, i, j, ..., drop=FALSE) {

    intensities <- getIntensities(x)
    weights <- getWeights(x)
    spotattr <- getSpotAttr(x)
    hybattr <- getHybAttr(x)
    
    if( missing(i) & missing(j) ){

      return(x)
      
    }else if( missing(i) ){

      if( ! is.null(intensities) ){
        intensities <- intensities[,,j,drop=FALSE]
      }
      if( ! is.null(weights) ){
        weights <- weights[,j,drop=FALSE]
      }
      if( ! is.null(spotattr) ){
        spotattr <- spotattr[,,drop=FALSE]
      }
      if( ! is.null(hybattr) ){
        hybattr <- hybattr[j,,drop=FALSE]
      }
      
    }else if( missing(j) ){

      if( ! is.null(intensities) ){
        intensities <- intensities[i,,,drop=FALSE]
      }
      if( ! is.null(weights) ){
        weights <- weights[i,,drop=FALSE]
      }
      if( ! is.null(spotattr) ){
        spotattr <- spotattr[i,,drop=FALSE]
      }
      if( ! is.null(hybattr) ){
        hybattr <- hybattr[,,drop=FALSE]
      }
      
    }else if( !missing(i) & !missing(j) ){

      if( ! is.null(intensities) ){
        intensities <- intensities[i,,j,drop=FALSE]
      }
      if( ! is.null(weights) ){
        weights <- weights[i,j,drop=FALSE]
      }
      if( ! is.null(spotattr) ){
        spotattr <- spotattr[i,,drop=FALSE]
      }
      if( ! is.null(hybattr) ){
        hybattr <- hybattr[j,,drop=FALSE]
      }
      
    }else{
      stop(" unexpected case in [ ")
    }

    aD <- new("arrayData", intensities=intensities, weights=weights, spotattr=spotattr, hybattr=hybattr)

    return(aD)
    
  }, where=where)


  
  ###################
  
  setClass(Class="normaliseResult", representation =
           representation(normData="array", normObject="ANY"),
           prototype = prototype(normData=array(), normObject=NA),
           where=where)

  setGeneric("getNormData", function(object) standardGeneric("getNormData"), where=where)
  setMethod("getNormData", "normaliseResult", function(object) object@normData, where=where)

  setGeneric("getNormObject", function(object) standardGeneric("getNormObject"), where=where)
  setMethod("getNormObject", "normaliseResult", function(object) object@normObject, where=where)

   
}
