%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file was automatically generated by Rdoc on 2003-09-26 13:36:30.
% Do NOT modify this file, instead modify the source (/net/herkules/raid6/home/buness/R/Rpacks/arrayMagicCore/arrayMagic/R/removeSpots.R).
% Rdoc is copyright (C) 2001, Henrik Bengtsson, henrikb@braju.com.
% Download the Rdoc compiler at http://www.braju.com/R/
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


 \name{removeSpots}

 \title{removeSpots}

 \alias{removeSpots}

 \keyword{}

 \description{all elements matching the strings in \code{spotsToBeRemoved}
              are taken out of the object \code{arrayDataObject} and if
              supplied out of the object \code{exprSetArrayObject} as well}

 \value{list containing
        an object of type \code{arrayData} labelled arrayDataObject
        and an integer specifying the number of removed items
        labelled nrOfRemovedItems
        and possily an object of type \code{exprSetArray}
        labelled \code{exprSetArrayObject} }


 \arguments{
  \item{arrayDataObject}{object of type \code{arrayData}; required; default missing}
  \item{exprSetArrayObject}{object of type \code{exprSetArray}; optional; default NULL}
  \item{spotIdentifier}{character strings name of the appropriate column; default "Name"}
  \item{spotsToBeRemoved}{vector of character strings; default \code{NULL}}
 }
 
 \details{}

 \seealso{\code{}}

 \examples{
  intensities <- array(data=runif(600),dim=c(100,2,3))
  dimnames(intensities) <- list(NULL, c("Cy3","Cy5"), NULL)
  arrayDataObject <- new("arrayData", intensities=intensities, spotattr=data.frame(Name=I(rep(c("x","y","Blank","Blank","z"),20))), hybattr=NULL)
  res <- removeSpots(arrayDataObject, spotsToBeRemoved=c("x","z"))
  stopifnot( dim(getIntensities(res[["arrayDataObject"]]))[1] == 3*20 )
  indCy3=1:3
  indCy5=4:6
  channels <- matrix( c(indCy3,indCy5), nrow=length(indCy3), byrow=FALSE )
  colnames(channels) <- c("Cy3","Cy5")
  exprSetArrayObject <- new("exprSetArray", exprs=matrix(data=runif(600),nrow=100,ncol=6), phenoData=new("phenoData", pData=data.frame(matrix(0,nrow=6,ncol=1)), varLabels=list(rep("varLabel1",1))), channels=channels)
  res2 <- removeSpots(arrayDataObject=arrayDataObject,exprSetArrayObject=exprSetArrayObject, spotsToBeRemoved=c("x","z"))
  stopifnot( dim(exprs(res2[["exprSetArrayObject"]]))[1] == 3*20 )
  res3 <- removeSpots(arrayDataObject=arrayDataObject,exprSetArrayObject=exprSetArrayObject, spotsToBeRemoved=c("ggrrrr"))
  stopifnot( dim(exprs(res3[["exprSetArrayObject"]]))[1] == 100 )
  stopifnot( dim(getIntensities(res3[["arrayDataObject"]]))[1] == 100 )
	}

 \keyword{}

 \author{Andreas Buness <a.buness@dkfz.de>}
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% End of File
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
