\name{rowFtests}
\alias{rowFtests}
\alias{rowttests}
\title{F-test and t-test for rows of a matrix}
\description{F-test and t-test for rows of a matrix}

\usage{
rowFtests(x, fac)
rowttests(x, fac)} 

\arguments{
  \item{x}{Matrix}
  \item{fac}{Factor, with \code{length(fac)=ncol(x)}. For
    \code{rowttests}, \code{fac} must have exactly two levels.}
}

\value{  
A list with the test statistics, p-values, degrees of freedom.
}
\author{Wolfgang Huber <w.huber@dkfz.de>}
\seealso{\code{\link[multtest:mt.teststat]{mt.teststat}}}
\examples{
   x  = matrix(runif(1e5), ncol=100)
   k2 = floor(runif(ncol(x))*2)
   k7 = floor(runif(ncol(x))*7)

   tt = rowttests(x, factor(k2))
   ft = rowFtests(x, factor(k7))

   if(require(multtest)) {
     fs = mt.teststat(x, k7, test="f")
     stopifnot(all(abs(fs - ft$statistic) < 1e-6))

     ts = mt.teststat(x, k2, test="t.equalvar")
     stopifnot(all(abs(ts - tt$statistic) < 1e-6))
   }
}
\keyword{math}
